#ifndef __MAX80_DEFS_H__
#define __MAX80_DEFS_H__

#include <Arduino.h>

#define TRUE 1
#define FALSE 0
// Software config
#define MAX80_FWVERSION    1
#define MAX80_HWVERSION 	101

// Serial port settings
#define MAX80_SERIAL_BAUD_RATE 921600


//Logging
#define MAX80_LOGGING_ENABLE_SERIAL
#ifndef MAX80_LOGGING_SERIAL_PORT
#define MAX80_LOGGING_SERIAL_PORT 		Serial
#endif
#define MAX80_LOGGING_VERBOSE_LEVEL 	5

//WIFI
#ifndef MAX80_WIFI_RETRY_TIMEOUT
#define MAX80_WIFI_RETRY_TIMEOUT 		00
#endif

#ifndef MAX80_WIFI_TIMEOUT_MS 
#define MAX80_WIFI_TIMEOUT_MS			10000 
#endif 

#ifndef MAX80_WIFI_RECOVER_TIME_MS 
#define MAX80_WIFI_RECOVER_TIME_MS 		30000 
#endif 


#define MAX80_WIFI_SSID				"MAX80"
#define MAX80_WIFI_PSK				"max80!!!"
#define MAX80_WIFI_HOSTNAME			"ABC80-MAX80"
#define MAX80_SPIFFS_CONFIG_PART  	"data"
#define MAX80_CONFIG_FILNAME	  	"/config"
	

#define MAX80_SPIFFS_PATH			"/"
#define MAX80_SPIFFS_PARTITION		"data"

#define SSID_MAX_LEN            32
#define PASS_MAX_LEN            64

typedef struct
{
  char wifi_ssid[SSID_MAX_LEN];
  char wifi_pw  [PASS_MAX_LEN];
}  max80config;



#define NUM_WIFI_CREDENTIALS      1

typedef struct
{
  max80config  WiFi_Creds [NUM_WIFI_CREDENTIALS];
  uint16_t checksum;
} max80Config;
#endif