#include "Arduino.h"
#include "port.h"
#include "esp32-hal-log.h"
#include "WiFi.h"
#include "max80_func.h"
#include "max80_callback.h"
#include "max80_gpio.h"
#include "max80_littlefs.h"
#include "max80_wifi.h"
#include "max80_web.h"
#include "esp_log.h"
#include <AsyncElegantOTA.h>
#include <DNSServer.h>
#include <WiFiMulti.h>
#include <ESP32DMASPISlave.h>
#include <USB.h>
#include "programmer.h"
#define LOG_LOCAL_LEVEL ESP_LOG_INFO


#define ARDUINO_USB_CDC_ON_BOOT

static const char TAG[] = __FILE__;


max80::std_max80 max80_std;
max80::callback max80_callback;
max80::wifi max80_wifi;
max80::gpio max80_gpio;
max80::littlefs max80_littlefs;
max80::web max80_web;
max80config max80_configuration;
AsyncElegantOtaClass AsyncElegantOTA;
DNSServer dns;
AsyncWebServer webserver(80);   
TaskHandle_t Config_Task = NULL;
ESP32DMASPI::Slave fpgaspislave;
String macaddr;
WiFiMulti wifiMulti;
TaskHandle_t ledtask = NULL;
portMUX_TYPE sync_isr = portMUX_INITIALIZER_UNLOCKED;
TimerHandle_t max80_ntp_timer = NULL;
max80Config max80_config;  
USBCDC USBSerial; 
void setup()
{
  Serial.begin(MAX80_SERIAL_BAUD_RATE);
  max80_littlefs.setup();
  max80_littlefs.loadconfig();
  max80_gpio.init();
  USBSerial.begin(921600);
  USBSerial.setRxBufferSize(4096);
  USB.begin();
  USBSerial.setRxBufferSize(4096);
  Serial.setRxBufferSize(4096);
  digitalWrite(MAX80_LED1,LOW);
  digitalWrite(MAX80_LED2,LOW);
  digitalWrite(MAX80_LED3,LOW);
  xTaskCreate(&blink_led,"ledcontrol",1024,NULL,5,&ledtask);
  uint32_t led;
  led = 500 << 8 | 1; 
  //ProgrammerInit();
  if (xTaskNotify(ledtask, led, eSetValueWithoutOverwrite) ==	pdTRUE) {
	}
  max80_wifi.setup();
}

void loop()
{

    delay(1000);
    if (!WiFi.isConnected()){
      max80_wifi.reconnect();
    }
    //ProgrammerLoop();
    //ESP_LOGD(TAG,"HEJ");
    USBSerial.println("Hej");
}